// SettingsDialogQueueImages.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "resource.h"       // main symbols
#include "aerosubc.h"
#include "aeroglss.h"
#include "SettingsDialog.h"
#include "registry.h"
#include "MainHelperQ.h"
#include "GdiplusWrapper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

bool ParsePath(CString sPath, int nLevel, CString *const psDirName)
{
    ASSERT(psDirName);
    //find first match
    int nStart = 0;                                 //Location in sPath to search from
    while (nLevel)
    {
        nStart = sPath.Find(_T('\\'), nStart);
        if (nStart < 0)
            return false;
        nLevel--;
        nStart++;
    }
    //We now have the start point to find the end.
    int nEnd = sPath.Find(_T('\\'), nStart);
    if (nEnd < 0)
        *psDirName = sPath.Mid(nStart);
    else
        *psDirName = sPath.Mid(nStart, nEnd - nStart);
    return true;
}

TCHAR* MakeObjectDynamic(LPTSTR szData)
{
    //Assume a NULL = empty string
    TCHAR* szRet = NULL;
    int nLength = 0;
    if (szData)
        nLength = _tcslen(szData) + 1;
    if (nLength > 0)
    {
        szRet = new TCHAR[nLength];
        ASSERT(szRet);
        _tcscpy(szRet, szData);
    }
    return szRet;
}

// Bote de dialogue CDialogYesNoAll
IMPLEMENT_DYNAMIC(CDialogYesNoAll, CDialog)

CDialogYesNoAll::CDialogYesNoAll(CString filen) : CDialog(CDialogYesNoAll::IDD)
{
    result = 0;
    filename = filen;
}

CDialogYesNoAll::~CDialogYesNoAll()
{
}

void CDialogYesNoAll::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);

    DDX_Control(pDX, IDC_PREVIEW3, m_picPreview);
    DDX_Control(pDX, IDC_TYPE, m_stType);
    DDX_Control(pDX, IDC_HEIGHT, m_stHeight);
    DDX_Control(pDX, IDC_WIDTH, m_stWidth);
}

BOOL CDialogYesNoAll::OnInitDialog()
{
    CDialog::OnInitDialog();

    AeroAutoSubclass(m_hWnd, ASC_SUBCLASS_ALL_CONTROLS, 0L);

    translate();

    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CDialogYesNoAll::OnEraseBkgnd(CDC* pDC)
{
    CDwmApiImpl dwmApi;
    if (dwmApi.Initialize() && dwmApi.IsDwmCompositionEnabled())
    {
        CRect rcClient;
        GetClientRect(&rcClient);

        VERIFY(pDC->PatBlt(0, 0, rcClient.Width(), rcClient.Height(), BLACKNESS));
        return TRUE;
    }
    return CDialog::OnEraseBkgnd(pDC);
}

void CDialogYesNoAll::OnBnClickedYes()
{
    result = IDYES;

    CDialog::OnOK();
}

void CDialogYesNoAll::OnBnClickedNo()
{
    result = IDNO;

    CDialog::OnOK();
}

void CDialogYesNoAll::OnBnClickedYesToAll()
{
    result = IDOK;

    CDialog::OnOK();
}

void CDialogYesNoAll::OnBnClickedNoToAll()
{
    result = IDCANCEL;

    CDialog::OnOK();
}

BEGIN_MESSAGE_MAP(CDialogYesNoAll, CDialog)
    ON_WM_ERASEBKGND()
    ON_BN_CLICKED(IDC_BNYES, OnBnClickedYes)
    ON_BN_CLICKED(IDC_BNNO, OnBnClickedNo)
    ON_BN_CLICKED(IDC_BNYESTOALL, OnBnClickedYesToAll)
    ON_BN_CLICKED(IDC_BNNOTOALL, OnBnClickedNoToAll)
END_MESSAGE_MAP()

void CDialogYesNoAll::DrawPreview()
{
    USES_CONVERSION;

    CString cstrWidth, cstrHeight, cstrType;
    UINT uiWidth, uiHeight;
    UINT thumbWidth, thumbHeight;
    int iAdjTop, iAdjLeft;
    int iCount = 0;
    double dRatio;
    CDC* pDC;
    CString szBuf;
    RECT rect;
    BOOL bExists = TRUE;

    if (!IsWindowVisible())
        return;

    // Initialize the Graphics class in GDI+.
    pDC = m_picPreview.GetWindowDC();
    Graphics graphics(pDC->m_hDC);

    // Fill the preview ara with a WHITE background.
    m_picPreview.GetClientRect(&rect);
    rect.left += 1;
    rect.top += 1;
    rect.right -= 1;
    rect.bottom -= 1;
    pDC->FillSolidRect(&rect, RGB(255, 255, 255));

    szBuf = filename;
    // Make sure the image exists
    CFile file;
    if (file.Open(szBuf, CFile::modeRead))
        file.Close();
    else
        bExists = FALSE;

    if (bExists)
    {
        try
        {
            // Use the Image class to display a thumbnail of the image.
            Image image(T2CW(szBuf));

            // Determine the appropriate size of the thumbnail preview
            // given the image size ratio and the preview window size ratio.
            uiWidth = image.GetWidth();
            uiHeight = image.GetHeight();
            dRatio = ((double)uiWidth) / ((double)uiHeight);

            // If the width is larger than the height of the image,
            // set the width of the thumbnail to the width of the preview area
            // and calculate the thumbnail height by using the ratios.
            // If the height is larger than the width of the image,
            // set the height of the thumbnail to the height of the preview area
            // and calculate the thumbnail width by using the ratios.
            if (uiWidth > uiHeight)
            {
                thumbWidth = rect.right - rect.left;
                thumbHeight = (UINT)(thumbWidth / dRatio);

                if (thumbHeight == 0)
                    thumbHeight = 1;
                if (thumbHeight > (UINT)(rect.bottom - rect.top))
                    thumbHeight = rect.bottom - rect.top;

                // Adjust things to make the preview not paint over the control border.
                iAdjTop = 1 + ((rect.bottom - rect.top) / 2) - (thumbHeight / 2);
                iAdjLeft = 1;
            }
            else
            {
                thumbHeight = rect.bottom - rect.top;
                thumbWidth = (UINT)(uiWidth * thumbHeight / uiHeight);

                if (thumbWidth == 0)
                    thumbWidth = 1;
                if (thumbWidth > (UINT)(rect.right - rect.left))
                    thumbWidth = rect.right - rect.left;

                // Adjust things to make the preview not paint over the control border.
                iAdjTop = 1;
                iAdjLeft = 1 + ((rect.right - rect.left) / 2) - (thumbWidth / 2);
            }

            // Get the thumbnail and display it in the preview control.
            Image* pThumbnail = image.GetThumbnailImage(thumbWidth, thumbHeight, NULL, NULL);
            graphics.DrawImage(pThumbnail, iAdjLeft, iAdjTop, pThumbnail->GetWidth(), pThumbnail->GetHeight());
            delete pThumbnail;

            // Display the image width and height.
            CString buf = m_Helper.MyLoadString(IDS_WIDTH);
            cstrWidth.Format(_T("%s %d"), buf, uiWidth);
            m_stWidth.SetWindowText(cstrWidth);
            buf = m_Helper.MyLoadString(IDS_HEIGHT);
            cstrHeight.Format(_T("%s %d"), buf, uiHeight);
            m_stHeight.SetWindowText(cstrHeight);

            // Display the image bits per pixel (color depth).
            buf = m_Helper.MyLoadString(IDS_TYPE);
            switch (image.GetPixelFormat())
            {
                case PixelFormat1bppIndexed:
                    cstrType.Format(_T("%s %s"), buf, m_Helper.MyLoadString(IDS_1BPP));
                    break;
                case PixelFormat4bppIndexed:
                    cstrType.Format(_T("%s %s"), buf, m_Helper.MyLoadString(IDS_4BPP));
                    break;
                case PixelFormat8bppIndexed:
                    cstrType.Format(_T("%s %s"), buf, m_Helper.MyLoadString(IDS_8BPP));
                    break;
                case PixelFormat16bppARGB1555:
                case PixelFormat16bppGrayScale:
                case PixelFormat16bppRGB555:
                case PixelFormat16bppRGB565:
                    cstrType.Format(_T("%s %s"), buf, m_Helper.MyLoadString(IDS_16BPP));
                    break;
                case PixelFormat24bppRGB:
                    cstrType.Format(_T("%s %s"), buf, m_Helper.MyLoadString(IDS_24BPP));
                    break;
                case PixelFormat32bppARGB:
                case PixelFormat32bppPARGB:
                case PixelFormat32bppRGB:
                    cstrType.Format(_T("%s %s"), buf, m_Helper.MyLoadString(IDS_32BPP));
                    break;
                case PixelFormat48bppRGB:
                    cstrType.Format(_T("%s %s"), buf, m_Helper.MyLoadString(IDS_48BPP));
                    break;
                case PixelFormat64bppARGB:
                case PixelFormat64bppPARGB:
                    cstrType.Format(_T("%s %s"), buf, m_Helper.MyLoadString(IDS_64BPP));
                    break;
                default:
                    cstrType.Format(_T("%s %s"), buf, m_Helper.MyLoadString(IDS_UNKNOWN));
                    break;
            }

            m_stType.SetWindowText(cstrType);
        }
        catch (...)
        {
        }
    }
    else
    {
        COLORREF oldCR = pDC->SetTextColor(RGB(255, 0, 0));
        //TODO
        pDC->DrawText(m_Helper.MyLoadString(IDS_FILENOTEXIST), &rect, DT_CENTER | DT_WORDBREAK);
        pDC->SetTextColor(oldCR);

        // No image to preview.
        CString buf = m_Helper.MyLoadString(IDS_WIDTH);
        m_stWidth.SetWindowText(buf);
        buf = m_Helper.MyLoadString(IDS_HEIGHT);
        m_stHeight.SetWindowText(buf);
        buf = m_Helper.MyLoadString(IDS_TYPE);
        m_stType.SetWindowText(buf);
    }

    if (pDC)
        ReleaseDC(pDC);  // Release the device context retrieved earlier.
}

void CDialogYesNoAll::translate()
{
    if (this->m_hWnd != NULL)
    {
        m_Helper.translateDlgItemText(this, IDC_BNYES);
        m_Helper.translateDlgItemText(this, IDC_BNNO);
        m_Helper.translateDlgItemText(this, IDC_BNYESTOALL);
        m_Helper.translateDlgItemText(this, IDC_BNNOTOALL);
        CString message;
        message.Format(m_Helper.MyLoadString(IDS_ALREADYEXIST), filename);
        GetDlgItem(IDC_MESSAGE)->SetWindowText(message);
        m_Helper.translateDlgItemText(this, IDC_INFOIMG);
        m_Helper.translateDlgItemText(this, IDC_WIDTH);
        m_Helper.translateDlgItemText(this, IDC_HEIGHT);
        m_Helper.translateDlgItemText(this, IDC_TYPE);
    }
}

int CDialogYesNoAll::GetResult()
{
    return result;
}

// Bote de dialogue CSettingsDialogQueueImages
IMPLEMENT_DYNAMIC(CSettingsDialogQueueImages, CPropertyPage)

CSettingsDialogQueueImages::CSettingsDialogQueueImages() : CPropertyPage(CSettingsDialogQueueImages::IDD)
{
    dialogYesNoAll = NULL;
    m_hNetworkRoot = NULL;
    m_cstrSearch.Add(_T(".bmp"));
    m_cstrSearch.Add(_T(".jpg"));
    m_cstrSearch.Add(_T(".jpeg"));
    m_cstrSearch.Add(_T(".gif"));
    m_cstrSearch.Add(_T(".dib"));
    m_cstrSearch.Add(_T(".png"));
}

CSettingsDialogQueueImages::~CSettingsDialogQueueImages()
{
}

void CSettingsDialogQueueImages::DoDataExchange(CDataExchange* pDX)
{
    CPropertyPage::DoDataExchange(pDX);

    DDX_Control(pDX, IDC_BROWSELIST, m_lbBrowseList);
    DDX_Control(pDX, IDC_PREVIEW2, m_picPreview);
    DDX_Control(pDX, IDC_TYPE, m_stType);
    DDX_Control(pDX, IDC_HEIGHT, m_stHeight);
    DDX_Control(pDX, IDC_WIDTH, m_stWidth);
    DDX_Control(pDX, IDC_TREE1, m_Tree);
}

BOOL CSettingsDialogQueueImages::OnInitDialog()
{
    CPropertyPage::OnInitDialog();

    AeroAutoSubclass(m_hWnd, ASC_SUBCLASS_ALL_CONTROLS, 0L);

    translate();

    // Initialize or reset dialog controls.
    ResetMainDialog();

    //
    //Setup the Image lists
    //
    m_ImageListTree.Create(IDB_FILE_TYPES, 17, 1, RGB(255, 255, 255));
    m_Tree.SetImageList(&m_ImageListTree, TVSIL_NORMAL);

    //
    //List the local drives
    //
    for (TCHAR cLetter = _T('A'); cLetter <= _T('Z'); cLetter++)
    {
        CString sDrive;
        sDrive.Format(_T("%c:"), cLetter);
        UINT nType = GetDriveType(sDrive + _T("\\"));
        if (DRIVE_REMOVABLE <= nType && nType <= DRIVE_RAMDISK)
            InsertItem(TVI_ROOT, TVI_LAST, NULL, sDrive, nType);
    }
    //Network neighbour hood
    m_hNetworkRoot = InsertItem(TVI_ROOT, TVI_LAST, NULL, m_Helper.MyLoadString(IDS_NETWORKNEIGHBORHOOD), DRIVE_RAMDISK + 1);

    //
    //Expand the Tree to the Inital Path.
    //
    int nLevel = 0;
    CString sDirName;
    HTREEITEM hCurrent = TVI_ROOT;                  //Current item in the list being expanded.
    CString tmpstrBrowsePath = m_cstrBrowsePath;
    while (ParsePath(tmpstrBrowsePath, nLevel, &sDirName))
    {
        //Network or Drive expand
        if (!nLevel && sDirName.IsEmpty())
            sDirName = m_Helper.MyLoadString(IDS_NETWORKNEIGHBORHOOD);
        //Search for the matching tree item and expand
        HTREEITEM hItem = m_Tree.GetChildItem(hCurrent);
        while (hItem)
        {
            if (sDirName.CompareNoCase(m_Tree.GetItemText(hItem)) == 0)
            {
                hCurrent = hItem;
                m_Tree.Expand(hCurrent, TVE_EXPAND);
                break;
            }
            hItem = m_Tree.GetNextSiblingItem(hItem);
        }
        nLevel++;
    }

    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CSettingsDialogQueueImages::OnEraseBkgnd(CDC* pDC)
{
    CDwmApiImpl dwmApi;
    if (dwmApi.Initialize() && dwmApi.IsDwmCompositionEnabled())
    {
        CRect rcClient;
        GetClientRect(&rcClient);

        VERIFY(pDC->PatBlt(0, 0, rcClient.Width(), rcClient.Height(), BLACKNESS));
        return TRUE;
    }
    return CPropertyPage::OnEraseBkgnd(pDC);
}

void CSettingsDialogQueueImages::OnOK()
{
    UpdateData(TRUE);

    CPropertyPage::OnOK();
}

BEGIN_MESSAGE_MAP(CSettingsDialogQueueImages, CPropertyPage)
    ON_WM_ERASEBKGND()
    ON_NOTIFY(TVN_SELCHANGED, IDC_TREE1, OnSelchangedTree)
    ON_NOTIFY(TVN_ITEMEXPANDING, IDC_TREE1, OnItemexpandingTree)
    ON_NOTIFY(TVN_KEYDOWN, IDC_TREE1, OnKeyDown)
    ON_LBN_SELCHANGE(IDC_BROWSELIST, DrawPreview)
    ON_BN_CLICKED(IDC_ADD, OnBnClickedAdd)
    ON_BN_CLICKED(IDC_ADDALL, OnBnClickedAddAll)
    ON_BN_CLICKED(IDC_ADDALL_RECURSIVE, OnBnClickedAddAllRecursively)
END_MESSAGE_MAP()

void CSettingsDialogQueueImages::DrawPreview()
{
    USES_CONVERSION;

    CString cstrWidth, cstrHeight, cstrType;
    UINT uiWidth, uiHeight;
    UINT thumbWidth, thumbHeight;
    int iAdjTop, iAdjLeft;
    int iCount = 0;
    double dRatio;
    CDC* pDC;
    CString szBuf;
    RECT rect;
    BOOL bExists = TRUE;

    if (!IsWindowVisible())
        return;

    // Initialize the Graphics class in GDI+.
    pDC = m_picPreview.GetWindowDC();
    Graphics graphics(pDC->m_hDC);

    // Fill the preview ara with a WHITE background.
    m_picPreview.GetClientRect(&rect);
    rect.left += 1;
    rect.top += 1;
    rect.right -= 1;
    rect.bottom -= 1;
    pDC->FillSolidRect(&rect, RGB(255, 255, 255));

    iCount = m_lbBrowseList.GetCount();  // BrowseList has focus, so get its count.

    if (iCount > 0)
    {
        // Get the path to the image from the list with focus.
        m_lbBrowseList.GetText(m_lbBrowseList.GetCurSel(), szBuf);

        // Make sure there is an image chosen.
        if (szBuf != "")
        {
            szBuf = m_cstrBrowsePath + szBuf;
            // Make sure the image exists
            CFile file;
            if (file.Open(szBuf, CFile::modeRead))
                file.Close();
            else
                bExists = FALSE;

            if (bExists)
            {
                try
                {
                    // Use the Image class to display a thumbnail of the image.
                    Image image(T2CW(szBuf));

                    // Determine the appropriate size of the thumbnail preview
                    // given the image size ratio and the preview window size ratio.
                    uiWidth = image.GetWidth();
                    uiHeight = image.GetHeight();
                    dRatio = ((double)uiWidth) / ((double)uiHeight);

                    // If the width is larger than the height of the image,
                    // set the width of the thumbnail to the width of the preview area
                    // and calculate the thumbnail height by using the ratios.
                    // If the height is larger than the width of the image,
                    // set the height of the thumbnail to the height of the preview area
                    // and calculate the thumbnail width by using the ratios.
                    if (uiWidth > uiHeight)
                    {
                        thumbWidth = rect.right - rect.left;
                        thumbHeight = (UINT)(thumbWidth / dRatio);

                        if (thumbHeight == 0)
                            thumbHeight = 1;
                        if (thumbHeight > (UINT)(rect.bottom - rect.top))
                            thumbHeight = rect.bottom - rect.top;

                        // Adjust things to make the preview not paint over the control border.
                        iAdjTop = 1 + ((rect.bottom - rect.top) / 2) - (thumbHeight / 2);
                        iAdjLeft = 1;
                    }
                    else
                    {
                        thumbHeight = rect.bottom - rect.top;
                        thumbWidth = (UINT)(uiWidth * thumbHeight / uiHeight);

                        if (thumbWidth == 0)
                            thumbWidth = 1;
                        if (thumbWidth > (UINT)(rect.right - rect.left))
                            thumbWidth = rect.right - rect.left;

                        // Adjust things to make the preview not paint over the control border.
                        iAdjTop = 1;
                        iAdjLeft = 1 + ((rect.right - rect.left) / 2) - (thumbWidth / 2);
                    }

                    // Get the thumbnail and display it in the preview control.
                    Image* pThumbnail = image.GetThumbnailImage(thumbWidth, thumbHeight, NULL, NULL);
                    graphics.DrawImage(pThumbnail, iAdjLeft, iAdjTop, pThumbnail->GetWidth(), pThumbnail->GetHeight());
                    delete pThumbnail;

                    // Display the image width and height.
                    CString buf = m_Helper.MyLoadString(IDS_WIDTH);
                    cstrWidth.Format(_T("%s %d"), buf, uiWidth);
                    m_stWidth.SetWindowText(cstrWidth);
                    buf = m_Helper.MyLoadString(IDS_HEIGHT);
                    cstrHeight.Format(_T("%s %d"), buf, uiHeight);
                    m_stHeight.SetWindowText(cstrHeight);

                    // Display the image bits per pixel (color depth).
                    buf = m_Helper.MyLoadString(IDS_TYPE);
                    switch (image.GetPixelFormat())
                    {
                        case PixelFormat1bppIndexed:
                            cstrType.Format(_T("%s %s"), buf, m_Helper.MyLoadString(IDS_1BPP));
                            break;
                        case PixelFormat4bppIndexed:
                            cstrType.Format(_T("%s %s"), buf, m_Helper.MyLoadString(IDS_4BPP));
                            break;
                        case PixelFormat8bppIndexed:
                            cstrType.Format(_T("%s %s"), buf, m_Helper.MyLoadString(IDS_8BPP));
                            break;
                        case PixelFormat16bppARGB1555:
                        case PixelFormat16bppGrayScale:
                        case PixelFormat16bppRGB555:
                        case PixelFormat16bppRGB565:
                            cstrType.Format(_T("%s %s"), buf, m_Helper.MyLoadString(IDS_16BPP));
                            break;
                        case PixelFormat24bppRGB:
                            cstrType.Format(_T("%s %s"), buf, m_Helper.MyLoadString(IDS_24BPP));
                            break;
                        case PixelFormat32bppARGB:
                        case PixelFormat32bppPARGB:
                        case PixelFormat32bppRGB:
                            cstrType.Format(_T("%s %s"), buf, m_Helper.MyLoadString(IDS_32BPP));
                            break;
                        case PixelFormat48bppRGB:
                            cstrType.Format(_T("%s %s"), buf, m_Helper.MyLoadString(IDS_48BPP));
                            break;
                        case PixelFormat64bppARGB:
                        case PixelFormat64bppPARGB:
                            cstrType.Format(_T("%s %s"), buf, m_Helper.MyLoadString(IDS_64BPP));
                            break;
                        default:
                            cstrType.Format(_T("%s %s"), buf, m_Helper.MyLoadString(IDS_UNKNOWN));
                            break;
                    }

                    m_stType.SetWindowText(cstrType);
                }
                catch (...)
                {
                }
            }
            else
            {
                COLORREF oldCR = pDC->SetTextColor(RGB(255, 0, 0));
                //TODO
                pDC->DrawText(m_Helper.MyLoadString(IDS_FILENOTEXIST), &rect, DT_CENTER | DT_WORDBREAK);
                pDC->SetTextColor(oldCR);

                // No image to preview.
                CString buf = m_Helper.MyLoadString(IDS_WIDTH);
                m_stWidth.SetWindowText(buf);
                buf = m_Helper.MyLoadString(IDS_HEIGHT);
                m_stHeight.SetWindowText(buf);
                buf = m_Helper.MyLoadString(IDS_TYPE);
                m_stType.SetWindowText(buf);
            }
        }
        else
        {
            // No image to preview.
            CString buf = m_Helper.MyLoadString(IDS_WIDTH);
            m_stWidth.SetWindowText(buf);
            buf = m_Helper.MyLoadString(IDS_HEIGHT);
            m_stHeight.SetWindowText(buf);
            buf = m_Helper.MyLoadString(IDS_TYPE);
            m_stType.SetWindowText(buf);
        }
    }

    if (pDC)
        ReleaseDC(pDC);  // Release the device context retrieved earlier.
}

BOOL CSettingsDialogQueueImages::DestroyWindow()
{
    //Start at the root deleting.
    HTREEITEM hItemCur = m_Tree.GetRootItem();      //Current item under inspection

    //
    //While their is still data in the tree
    //
    while (hItemCur)
    {
        HTREEITEM hItem = m_Tree.GetChildItem(hItemCur);
        //Has children then make the child current
        if (hItem)
        {
            hItemCur = hItem;
            continue;
        }

        //Item has not children so we shall destroy it.
        //but first we must decide who is to take its place.
        HTREEITEM hNextSibItem = m_Tree.GetNextSiblingItem(hItemCur);
        HTREEITEM hPrevSibItem = m_Tree.GetPrevSiblingItem(hItemCur);
        HTREEITEM hParentItem = m_Tree.GetParentItem(hItemCur);
        //Get item data to check if lparam is to be destroyed
        NETRESOURCE *const pNetResource = (NETRESOURCE*)m_Tree.GetItemData(hItemCur);//(item.lParam);
        if (pNetResource)
        {
            delete[] (pNetResource->lpLocalName);
            delete[] (pNetResource->lpRemoteName);
            delete[] (pNetResource->lpComment);
            delete[] (pNetResource->lpProvider);
            delete pNetResource;
        }
        m_Tree.DeleteItem(hItemCur);
        hItemCur = NULL;
        //Determine which item is next to recieve the focus
        if (hParentItem)
            hItemCur = hParentItem;
        if (hPrevSibItem)
            hItemCur = hPrevSibItem;
        if (hNextSibItem)
            hItemCur = hNextSibItem;
    }
    //All items removed from list now. Lets trash this place and go home.
    return CDialog::DestroyWindow();
}

HTREEITEM CSettingsDialogQueueImages::InsertItem(HTREEITEM hParent, HTREEITEM hAfter, NETRESOURCE *const pNetResource, CString sText, int iImage, int iImageSelected /* = -1 */)
{
    TVINSERTSTRUCT InsertStruct;
    InsertStruct.hParent = hParent;
    InsertStruct.hInsertAfter = hAfter;
    InsertStruct.itemex.mask = TVIF_IMAGE | TVIF_TEXT | TVIF_CHILDREN | TVIF_SELECTEDIMAGE | TVIF_PARAM;
    InsertStruct.itemex.pszText = sText.GetBuffer(sText.GetLength());  sText.ReleaseBuffer();
    InsertStruct.itemex.iImage = iImage;
    InsertStruct.itemex.cChildren = 1;
    InsertStruct.itemex.lParam = (LPARAM)pNetResource;
    if (iImageSelected == -1)
        InsertStruct.itemex.iSelectedImage = iImage;
    else
        InsertStruct.itemex.iSelectedImage = iImageSelected;
    return m_Tree.InsertItem(&InsertStruct);
}

bool CSettingsDialogQueueImages::PopulateTree(CString sPath, HTREEITEM hParent)
{
    bool bGotChildren = false;                      //True if a child is added.
    //
    //Populate Network neighbourhood tree (Entire network and Local-Computers)
    //
    if (hParent == m_hNetworkRoot)
    {
        bGotChildren = EnumNetwork(hParent);
    }
    //
    //Network item(Search deep into the network)
    //
    else if (m_Tree.GetItemData(hParent))
    {
        bGotChildren = EnumNetwork(hParent);
    }

        //
        //Search for files and populate the CTreeCtrl
        //
    else
    {
        CFileFind finder;
        BOOL bWorking = finder.FindFile(sPath + _T("*.*"));
        while (bWorking)
        {
            bWorking = finder.FindNextFile();
            if (finder.IsDots())
                continue;
            if (finder.IsDirectory())
            {
                InsertItem(hParent, TVI_LAST, NULL, finder.GetFileName(), DRIVE_NO_ROOT_DIR, DRIVE_UNKNOWN);
                bGotChildren = true;
            }
        }
    }

    //
    //Remove the [+] if no children
    //
    if (!bGotChildren)
    {
        TVITEM item =
        {
            0
        };
        item.mask = TVIF_HANDLE | TVIF_CHILDREN;
        item.hItem = hParent;
        item.cChildren = 0;
        m_Tree.SetItem(&item);
    }
    return bGotChildren;
}

HTREEITEM CSettingsDialogQueueImages::GetItem(CString path)
{
    int nLevel = 0;
    CString sDirName;
    HTREEITEM hCurrent = TVI_ROOT;                  //Current item in the list being expanded.
    HTREEITEM hItem = NULL;
    CString tmpstrBrowsePath = path;
    while (ParsePath(tmpstrBrowsePath, nLevel, &sDirName))
    {
        //Network or Drive expand
        if (!nLevel && sDirName.IsEmpty())
            sDirName = m_Helper.MyLoadString(IDS_NETWORKNEIGHBORHOOD);
        //Search for the matching tree item and expand
        hItem = m_Tree.GetChildItem(hCurrent);
        while (hItem)
        {
            if (sDirName.CompareNoCase(m_Tree.GetItemText(hItem)) == 0)
            {
                hCurrent = hItem;
                break;
            }
            hItem = m_Tree.GetNextSiblingItem(hItem);
        }
        nLevel++;
    }
    return hItem;
}

CString CSettingsDialogQueueImages::GetItemPath(HTREEITEM hItem)
{
    CString sRet;
    if (hItem == NULL)
        return _T("");
    do
    {
        //End with a share name.
        NETRESOURCE *const pNetResource = (NETRESOURCE*)(m_Tree.GetItemData(hItem));
        if (pNetResource)
        {
            sRet = CString(pNetResource->lpRemoteName) + _T('\\') + sRet;
            break;
        }
        //Add the directory name to the path.
        sRet = m_Tree.GetItemText(hItem) + _T('\\') + sRet;
        hItem = m_Tree.GetParentItem(hItem);
    }
    while (hItem);
    return sRet;
}

void CSettingsDialogQueueImages::OnItemexpandingTree(NMHDR* pNMHDR, LRESULT* pResult)
{
    CWaitCursor CursorWaiting;                      //Show the wait cursor while expanding
    NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
    ASSERT(pNMTreeView);
    ASSERT(pResult);
    if (pNMTreeView->action == 2)
    {
        //Update location display
        CString sPath = GetItemPath(pNMTreeView->itemNew.hItem);
        //Refresh children
        if (!m_Tree.GetChildItem(pNMTreeView->itemNew.hItem))
        {
            PopulateTree(sPath, pNMTreeView->itemNew.hItem);
            if (m_Tree.GetSelectedItem() != pNMTreeView->itemNew.hItem)
                m_Tree.SelectItem(pNMTreeView->itemNew.hItem);
        }
    }
    if (pNMTreeView->action == 1)
    {
        //Update location display
        CString sPath = GetItemPath(pNMTreeView->itemNew.hItem);
        //Refresh children
        while (m_Tree.GetChildItem(pNMTreeView->itemNew.hItem))
        {
            m_Tree.DeleteItem(m_Tree.GetChildItem(pNMTreeView->itemNew.hItem));
        }
        pNMTreeView->itemNew.cChildren = 1;
        if ((pNMTreeView->itemNew.state & TVIS_EXPANDED) == TVIS_EXPANDED)
            pNMTreeView->itemNew.state -= TVIS_EXPANDED;
        m_Tree.SetItem(&pNMTreeView->itemNew);
    }
    *pResult = 0;
}

void CSettingsDialogQueueImages::OnSelchangedTree(NMHDR* pNMHDR, LRESULT* pResult)
{
    NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
    ASSERT(pNMTreeView);
    ASSERT(pResult);
    //Disable search on Workstation roots
    if (!m_Tree.GetItemData(pNMTreeView->itemNew.hItem) && pNMTreeView->itemNew.hItem != m_hNetworkRoot)
    {
        m_cstrBrowsePath = GetItemPath(pNMTreeView->itemNew.hItem);
    }
    *pResult = 0;

    FillList();
}

bool CSettingsDialogQueueImages::EnumNetwork(HTREEITEM hParent)
{
    bool bGotChildren = false;                      //True if a child is added. 

    //Check if the item already has a network resource and use it.
    NETRESOURCE *const pNetResource = (NETRESOURCE*)(m_Tree.GetItemData(hParent));
    //
    //Setup
    //
    DWORD dwResult;      
    HANDLE hEnum;      
    DWORD cbBuffer = 16384;
    DWORD cEntries = 0xFFFFFFFF;      
    LPNETRESOURCE lpnrDrv;      
    DWORD i;
    dwResult = WNetOpenEnum(pNetResource ? RESOURCE_GLOBALNET : RESOURCE_CONTEXT, RESOURCETYPE_ANY,//RESOURCETYPE_DISK,
                                0, pNetResource ? pNetResource : NULL, &hEnum);      
    //Was the read sucessfull
    if (dwResult != NO_ERROR)
    {
        TRACE(_T("*** ERROR %d - Cannot enumerate network drives.\n"), dwResult);
        return false;
    } 

    //
    //Get items until no more remain.
    //
    do
    {
        lpnrDrv = (LPNETRESOURCE)GlobalAlloc(GPTR, cbBuffer);
        dwResult = WNetEnumResource(hEnum, &cEntries, lpnrDrv, &cbBuffer);
        if (dwResult == NO_ERROR)
        {
            //Scann through the results
            for (i = 0; i < cEntries; i++)
            {
                CString sNameRemote = lpnrDrv[i].lpRemoteName;
                int nType = 9;
                if (sNameRemote.IsEmpty())
                {
                    sNameRemote = lpnrDrv[i].lpComment;
                    nType = 8;
                }
                //
                //Remove leading back slashes 
                //
                if (sNameRemote.GetLength() > 0 && sNameRemote[0] == _T('\\'))
                    sNameRemote = sNameRemote.Mid(1);
                if (sNameRemote.GetLength() > 0 && sNameRemote[0] == _T('\\'))
                    sNameRemote = sNameRemote.Mid(1);

                //
                //Display a share or the appropiate icon
                //
                if (lpnrDrv[i].dwDisplayType == RESOURCEDISPLAYTYPE_SHARE)
                {
                    //Display only the share name
                    int nPos = sNameRemote.Find(_T('\\'));
                    if (nPos >= 0)
                        sNameRemote = sNameRemote.Mid(nPos + 1);
                    InsertItem(hParent, TVI_LAST, NULL, sNameRemote, DRIVE_NO_ROOT_DIR, DRIVE_UNKNOWN);
                }
                else
                {
                    NETRESOURCE* pResource = new NETRESOURCE;
                    ASSERT(pResource);
                    *pResource = lpnrDrv[i];
                    pResource->lpLocalName = MakeObjectDynamic(pResource->lpLocalName);
                    pResource->lpRemoteName = MakeObjectDynamic(pResource->lpRemoteName);
                    pResource->lpComment = MakeObjectDynamic(pResource->lpComment);
                    pResource->lpProvider = MakeObjectDynamic(pResource->lpProvider);
                    InsertItem(hParent, TVI_LAST, pResource, sNameRemote, pResource->dwDisplayType + 7);
                }
                bGotChildren = true;
            }
        }         
        GlobalFree((HGLOBAL)lpnrDrv);      
        if (dwResult != ERROR_NO_MORE_ITEMS)
        {
            TRACE(_T("*** ERROR %d - Cannot complete network drive enumeration\n"), dwResult);
            break;
        }
    }
    while (dwResult != ERROR_NO_MORE_ITEMS);      

    //
    //Let go and go home
    //
    WNetCloseEnum(hEnum);   
    return bGotChildren;
}

void CSettingsDialogQueueImages::OnKeyDown(NMHDR* pNMHDR, LRESULT* pResult)
{
    NMTVKEYDOWN* pKeyDown = (NMTVKEYDOWN*)pNMHDR;
    ASSERT(pKeyDown);
    ASSERT(pResult);
    switch (pKeyDown->wVKey)
    {
        case VK_F5:
            {
                HTREEITEM hRoot = m_Tree.GetNextItem(NULL, TVGN_ROOT);
                HTREEITEM item = hRoot;
                HTREEITEM after = TVI_FIRST;
                //
                //List the local drives
                //
                for (TCHAR cLetter = _T('A'); cLetter <= _T('Z'); cLetter++)
                {
                    CString sDrive;
                    sDrive.Format(_T("%c:"), cLetter);
                    UINT nType = GetDriveType(sDrive + _T("\\"));
                    if (DRIVE_REMOVABLE <= nType && nType <= DRIVE_RAMDISK)
                    {
                        item = GetItem(sDrive);
                        if (item == NULL)
                        {
                            InsertItem(TVI_ROOT, after, NULL, sDrive, nType);
                        }
                        else
                        {
                            if (m_Tree.GetChildItem(GetItem(sDrive)))
                            {
                                Refresh(item);
                            }
                        }
                        after = item;
                    }
                    else
                    {
                        item = GetItem(sDrive);
                        if (item != NULL)
                            m_Tree.DeleteItem(item);
                    }
                }
                break;
            }
    }
}

void CSettingsDialogQueueImages::Refresh(HTREEITEM item)
{
    CString path = GetItemPath(item);
    CFileFind finder;

    HTREEITEM after = m_Tree.GetChildItem(item);

    while (after != NULL)
    {
        CString afterPath = GetItemPath(after);
        if (finder.FindFile(afterPath + _T("\\*.*")) == 0)
        {
            m_Tree.DeleteItem(after);
            after = m_Tree.GetChildItem(item);
        }
        after = m_Tree.GetNextItem(after, TVGN_NEXT);
    }

    BOOL bWorking = finder.FindFile(path + _T("*.*"));

    while (bWorking)
    {
        bWorking = finder.FindNextFile();
        if (finder.IsDots())
            continue;
        if (finder.IsDirectory())
        {
            CString dirName = finder.GetFileName();
            HTREEITEM dirItem = GetItem(path + dirName);
            if (dirItem == NULL)
            {
                HTREEITEM after = m_Tree.GetChildItem(item);
                CString afterPath = GetItemPath(after);

                while (after != NULL && afterPath.CompareNoCase(path + dirName) < 0)
                {
                    after = m_Tree.GetNextItem(after, TVGN_NEXT);
                    if (after != NULL)
                    {
                        afterPath = GetItemPath(after);
                    }
                }

                if (after == NULL)
                    after = TVI_LAST;

                InsertItem(item, after, NULL, dirName, DRIVE_NO_ROOT_DIR, DRIVE_UNKNOWN);
            }
            else
            {
                if (m_Tree.GetChildItem(dirItem))
                {
                    Refresh(dirItem);
                }
            }
        }
    }
}

void CSettingsDialogQueueImages::FillList()
{
    CFileFind finder;

    // Clear the list box.
    m_lbBrowseList.ResetContent();

    // Build the search string.
    if (m_cstrBrowsePath.GetAt(m_cstrBrowsePath.GetLength() - 1) != '\\')
        m_cstrBrowsePath += _T("\\");

    // Get all image files into the list.
    BOOL bWorking = finder.FindFile(m_cstrBrowsePath + _T("*.*"));
    while (bWorking)
    {
        bWorking = finder.FindNextFile();
        CString fileName = finder.GetFileName();
        if (!finder.IsDirectory())
        {
            for (int i = 0; i < m_cstrSearch.GetCount(); i++)
            {
                CString ext = m_cstrSearch[i];
                if (fileName.Right(ext.GetLength()) == ext)
                {
                    m_lbBrowseList.AddString(fileName);
                }
            }
        }
    }

    finder.Close();

    // Select the first image.
    if (m_lbBrowseList.GetCount() > 0)
    {
        m_lbBrowseList.SetSel(0);
        m_lbBrowseList.SetFocus();
        DrawPreview();
    }
}

void CSettingsDialogQueueImages::ResetMainDialog()
{
    CString cstrAppPath;
    TCHAR strBrowsePath[MAX_PATH + 1];
    // Initialize the strBrowsePath string to zeros.
    ZeroMemory(strBrowsePath, sizeof(char) * (MAX_PATH + 1));

    // Get the application path.
    GetModuleFileName(AfxGetInstanceHandle(), strBrowsePath, MAX_PATH + 1);
    cstrAppPath.Format(_T("%s"), strBrowsePath);
    cstrAppPath = cstrAppPath.Left(cstrAppPath.ReverseFind('\\') + 1);

    // Get the browse path for the top list box.
    m_cstrBrowsePath = CRegistry::GetRegString(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("LastPath"), cstrAppPath);

    RECT rect;

    // Set the scroll size of the browse list box.
    m_lbBrowseList.GetWindowRect(&rect);
    m_lbBrowseList.SetHorizontalExtent(rect.right - rect.left + 100);

    // Fill the top list box with all image files in the specified location.
    m_lbBrowseList.ResetContent();
    FillList();
}

void CSettingsDialogQueueImages::ApplyChanges()
{
    // Set the last browse path in the registry.
    CRegistry::SetRegString(_T("Software\\Desktop Calendar_V1.0\\DesktopCalendar\\Configuration"), _T("LastPath"), m_cstrBrowsePath);
}

void CSettingsDialogQueueImages::translate()
{
    if (this->m_hWnd != NULL)
    {
        m_Helper.translateWindowText(this, IDD_SETTINGS_QUEUE_IMAGES);
        m_Helper.translateDlgItemText(this, IDC_ADD);
        m_Helper.translateDlgItemText(this, IDC_ADDALL);
        m_Helper.translateDlgItemText(this, IDC_ADDALL_RECURSIVE);
        m_Helper.translateDlgItemText(this, IDC_INFOIMG2);
        m_Helper.translateDlgItemText(this, IDC_WIDTH);
        m_Helper.translateDlgItemText(this, IDC_HEIGHT);
        m_Helper.translateDlgItemText(this, IDC_TYPE);
    }
}

BOOL CSettingsDialogQueueImages::OnSetActive()
{
    CString buf = m_Helper.MyLoadString(IDC_LIMAGES_QUEUED);
    if (SettingsDialog->m_SettingsDialogImagesQueued.m_lbQList.m_hWnd != NULL)
    {
        CString tmp;
        tmp.Format(_T("%d %s"), SettingsDialog->m_SettingsDialogImagesQueued.m_lbQList.GetCount(), buf);
        GetDlgItem(IDC_IMAGES_QUEUED)->SetWindowText(tmp);
    }
    return TRUE;
}

void CSettingsDialogQueueImages::OnBnClickedAdd()
{
    int iCount, result = -1;
    CString cstrTemp;

    // Get all selected items from the browse list.
    iCount = m_lbBrowseList.GetSelCount();
    CArray<int, int> aryListBoxSel;

    aryListBoxSel.SetSize(iCount);
    m_lbBrowseList.GetSelItems(iCount, aryListBoxSel.GetData());

    // Loop through each selected item and add it to the Queue list.
    for (int i = 0; i < aryListBoxSel.GetSize(); i++)
    {
        m_lbBrowseList.GetText(aryListBoxSel.GetAt(i), cstrTemp);
        QueueImage(m_cstrBrowsePath + cstrTemp, &result);
    }

    CString buf = m_Helper.MyLoadString(IDC_LIMAGES_QUEUED);
    CString tmp;
    tmp.Format(_T("%d %s"), SettingsDialog->m_SettingsDialogImagesQueued.m_lbQList.GetCount(), buf);
    GetDlgItem(IDC_IMAGES_QUEUED)->SetWindowText(tmp);

    SettingsDialog->m_btnApply.EnableWindow();
}

void CSettingsDialogQueueImages::QueueImage(CString cstrImagePath, int* result)
{
    CString label;
    CString path = SettingsDialog->PrepareUrlImage(cstrImagePath);
    CDC* pDC = pDC = GetDC();
    int iPosition = GetWPPositionByImageSize(path, pDC->GetDeviceCaps(HORZRES), pDC->GetDeviceCaps(VERTRES));
    ReleaseDC(pDC);
    switch (iPosition)
    {
        case 0:
            label.Format(_T("%s (%s)"), cstrImagePath, m_Helper.MyLoadString(IDS_TILED));
            break;
        case 1:
            label.Format(_T("%s (%s)"), cstrImagePath, m_Helper.MyLoadString(IDS_CENTER));
            break;
        case 2:
            label.Format(_T("%s (%s)"), cstrImagePath, m_Helper.MyLoadString(IDS_STRETCH));
            break;
        case 3:
            label.Format(_T("%s (%s)"), cstrImagePath, m_Helper.MyLoadString(IDS_ADJUST));
            break;
        case 4:
            label.Format(_T("%s (%s)"), cstrImagePath, m_Helper.MyLoadString(IDS_ADJUSTFROMOUTSIDE));
            break;
        case 5:
            label.Format(_T("%s (%s)"), cstrImagePath, m_Helper.MyLoadString(IDS_AUTOSIZE));
            break;
    }

    // Select each newly added item.
    if (SettingsDialog->m_SettingsDialogImagesQueued.m_lbQList.FindString(0, cstrImagePath + _T(" (")) > -1)
    {
        CString label1;
        label1.Format(m_Helper.MyLoadString(IDS_ALREADYEXIST), cstrImagePath);
        BOOL ask = FALSE;
        int res = IDNO;
        if (result != NULL)
        {
            res = *result;
            if (*result != IDYES && *result != IDNO && *result != -1)
                ask = FALSE;
            else
                ask = TRUE;
        }
        // If its already in the list, ask if they want to add it again.
        if (ask == TRUE)
        {
            dialogYesNoAll = new CDialogYesNoAll(cstrImagePath);

            dialogYesNoAll->DoModal();

            res = dialogYesNoAll->GetResult();

            delete dialogYesNoAll;
            dialogYesNoAll = NULL;

            if (result != NULL)
            {
                *result = res;
            }
        }
        if (res == IDYES || res == IDOK)
        {
            int index = SettingsDialog->m_SettingsDialogImagesQueued.m_lbQList.GetCount();
            SettingsDialog->m_SettingsDialogImagesQueued.m_lbQList.InsertString(index, label);
            SettingsDialog->m_SettingsDialogImagesQueued.m_lbQList.SetItemData(index, iPosition);
        }
    }
    else
    {
        int index = SettingsDialog->m_SettingsDialogImagesQueued.m_lbQList.GetCount();
        SettingsDialog->m_SettingsDialogImagesQueued.m_lbQList.InsertString(index, label);
        SettingsDialog->m_SettingsDialogImagesQueued.m_lbQList.SetItemData(index, iPosition);
    }
}

int GetWPPositionByImageSize(CString cstrImagePath, UINT iHorzRes, UINT iVertRes)
{
    USES_CONVERSION;

    UINT uiWidth;
    UINT uiHeight;

    int iCalcPosition = 0;

    // Initialize the Graphics class in GDI+.
    Graphics graphics((HDC)NULL);

    // Use the Image class to get dimensions of the image.
    Image image(T2CW((LPCTSTR)cstrImagePath));

    uiWidth = image.GetWidth();
    uiHeight = image.GetHeight();

    if (uiWidth < iHorzRes / 2 && uiHeight < iVertRes / 2)
        iCalcPosition = 0; // Tiled
    else if (uiWidth < (iHorzRes * 3) / 4 && uiHeight < (iVertRes * 3) / 4)
        iCalcPosition = 1; // center
    else if (abs((int)(((iHorzRes * uiHeight) / uiWidth) - iVertRes)) > abs((int)(((iVertRes * uiWidth) / uiHeight) - iHorzRes)))
        iCalcPosition = 3; // Adjust
    else
        iCalcPosition = 4; // Adjust from the outside

    return iCalcPosition;
}

void CSettingsDialogQueueImages::OnBnClickedAddAll()
{
    CString cstrTemp;
    int result = -1;

    // Loop through each selected item and add it to the Queue list.
    for (int i = 0; i < m_lbBrowseList.GetCount(); i++)
    {
        m_lbBrowseList.GetText(i, cstrTemp);
        QueueImage(m_cstrBrowsePath + cstrTemp, &result);
    }

    CString buf = m_Helper.MyLoadString(IDC_LIMAGES_QUEUED);
    CString tmp;
    tmp.Format(_T("%d %s"), SettingsDialog->m_SettingsDialogImagesQueued.m_lbQList.GetCount(), buf);
    GetDlgItem(IDC_IMAGES_QUEUED)->SetWindowText(tmp);

    SettingsDialog->m_btnApply.EnableWindow();
}

void CSettingsDialogQueueImages::OnBnClickedAddAllRecursively()
{
    CFileFind finder;
    CStringArray recusivePath;
    int result = -1;

    recusivePath.Add(m_cstrBrowsePath);

    while (recusivePath.GetCount() != 0)
    {
        CString path = recusivePath[0];
        if (path.GetAt(path.GetLength() - 1) != '\\')
            path += _T("\\");
        recusivePath.RemoveAt(0);
        // Get all image files into the list.
        BOOL bWorking = finder.FindFile(path + _T("*.*"));
        while (bWorking)
        {
            bWorking = finder.FindNextFile();
            CString fileName = finder.GetFileName();
            if (!finder.IsDirectory())
            {
                for (int i = 0; i < m_cstrSearch.GetCount(); i++)
                {
                    CString ext = m_cstrSearch[i];
                    if (fileName.Right(ext.GetLength()) == ext)
                    {
                        QueueImage(path + fileName, &result);
                    }
                }
            }
            else
            {
                if (!finder.IsDots())
                {
                    recusivePath.Add(path + fileName);
                }
            }
        }

        finder.Close();
    }

    CString buf = m_Helper.MyLoadString(IDC_LIMAGES_QUEUED);
    CString tmp;
    tmp.Format(_T("%d %s"), SettingsDialog->m_SettingsDialogImagesQueued.m_lbQList.GetCount(), buf);
    GetDlgItem(IDC_IMAGES_QUEUED)->SetWindowText(tmp);

    SettingsDialog->m_btnApply.EnableWindow();
}
